'use strict';var Vue=require('vue'),addFormats=require('ajv-formats'),VueFormJsonSchema=require('vue-form-json-schema'),Cropper=require('cropperjs'),lodash=require('lodash');function _interopDefaultLegacy(e){return e&&typeof e==='object'&&'default'in e?e:{'default':e}}var Vue__default=/*#__PURE__*/_interopDefaultLegacy(Vue);var addFormats__default=/*#__PURE__*/_interopDefaultLegacy(addFormats);var VueFormJsonSchema__default=/*#__PURE__*/_interopDefaultLegacy(VueFormJsonSchema);var Cropper__default=/*#__PURE__*/_interopDefaultLegacy(Cropper);function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);

    if (enumerableOnly) {
      symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });
    }

    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]);

  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;

  var _s, _e;

  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}/*
 * src/schema-utils.js
 * Created: Wed May 26 2021 23:59:13 GMT+0530 (India Standard Time)
 * Copyright 2021 Harish Karumuthil<harish2704@gmail.com>
 */
var defaultFields = {};

defaultFields.input = function (name, schema) {
  return Object.assign({
    component: "app-input",
    model: name
  }, schema.ui);
};

defaultFields.select = function (name, schema) {
  return Object.assign({
    component: "app-select",
    model: name,
    enum: schema.enum
  }, schema.ui);
};

defaultFields.array = function (name, schema) {
  return Object.assign({
    component: "app-array-container",
    model: name,
    children: Object.entries(schema.properties).map(function (_ref) {
      var _ref2 = _slicedToArray(_ref, 2),
          name = _ref2[0],
          schema = _ref2[1];

      return defaultFields.default(name, schema);
    })
  }, schema.ui);
};

defaultFields.default = function (name, schema) {
  switch (schema.type) {
    case "array":
      return defaultFields.array(name, schema.items);

    default:
      if (schema.enum !== undefined) {
        return defaultFields.select(name, schema);
      }

      return defaultFields.input(name, schema);
  }
};

function getUiSchema(lightSchema) {
  return Object.entries(lightSchema.properties).map(function (_ref3) {
    var _ref4 = _slicedToArray(_ref3, 2),
        name = _ref4[0],
        schema = _ref4[1];

    return defaultFields.default(name, schema);
  });
}

function getJsonSchemaField(field) {
  var out;

  switch (field.type) {
    case "object":
      return getJsonSchema(field);

    case "array":
      return field.items.map(getJsonSchemaField);

    default:
      out = Object.assign({}, field, {
        ui: undefined
      });

      if (out.enum && _typeof(out.enum[0]) === "object") {
        out.enum = out.enum.map(function (v) {
          return v.value;
        });
      }

      return out;
  }
}

function getJsonSchema(fullSchema) {
  var out = Object.assign({}, fullSchema);
  out.properties = Object.assign({}, fullSchema.properties);
  var properties = out.properties;

  for (var key in properties) {
    properties[key] = getJsonSchemaField(properties[key]);
  }

  return out;
}

var schemaUtils = {
  defaultFields: defaultFields,
  getUiSchema: getUiSchema,
  getJsonSchema: getJsonSchema
};var script$7 = {
  mixins: [VueFormJsonSchema.vfjsFieldMixin],
  methods: {
    id: function id(index) {
      return "".concat(this.vfjsFieldId, "-").concat(index);
    },
    onChange: function onChange(index, model) {
      var newModel = this.vfjsFieldModel.slice();
      newModel[index] = model;
      this.setModel(newModel);
    },
    appendItem: function appendItem() {
      this.setModel((this.vfjsFieldModel || []).concat([{}]));
    },
    clone: function clone(index) {
      var newData = this.vfjsFieldModel.slice();
      newData.splice(index, 0, _objectSpread2({}, this.vfjsFieldModel[index]));
      this.setModel(newData);
    },
    remove: function remove(index) {
      this.vfjsFieldModel.splice(index, 1);
      this.setModel(this.vfjsFieldModel.slice());
    }
  }
};function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier /* server only */, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
    if (typeof shadowMode !== 'boolean') {
        createInjectorSSR = createInjector;
        createInjector = shadowMode;
        shadowMode = false;
    }
    // Vue.extend constructor export interop.
    const options = typeof script === 'function' ? script.options : script;
    // render functions
    if (template && template.render) {
        options.render = template.render;
        options.staticRenderFns = template.staticRenderFns;
        options._compiled = true;
        // functional template
        if (isFunctionalTemplate) {
            options.functional = true;
        }
    }
    // scopedId
    if (scopeId) {
        options._scopeId = scopeId;
    }
    let hook;
    if (moduleIdentifier) {
        // server build
        hook = function (context) {
            // 2.3 injection
            context =
                context || // cached call
                    (this.$vnode && this.$vnode.ssrContext) || // stateful
                    (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext); // functional
            // 2.2 with runInNewContext: true
            if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
                context = __VUE_SSR_CONTEXT__;
            }
            // inject component styles
            if (style) {
                style.call(this, createInjectorSSR(context));
            }
            // register component module identifier for async chunk inference
            if (context && context._registeredComponents) {
                context._registeredComponents.add(moduleIdentifier);
            }
        };
        // used by ssr in case component is cached and beforeCreate
        // never gets called
        options._ssrRegister = hook;
    }
    else if (style) {
        hook = shadowMode
            ? function (context) {
                style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
            }
            : function (context) {
                style.call(this, createInjector(context));
            };
    }
    if (hook) {
        if (options.functional) {
            // register for functional component in vue file
            const originalRender = options.render;
            options.render = function renderWithStyleInjection(h, context) {
                hook.call(context);
                return originalRender(h, context);
            };
        }
        else {
            // inject component registration as beforeCreate hook
            const existing = options.beforeCreate;
            options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
        }
    }
    return script;
}/* script */
var __vue_script__$7 = script$7;
/* template */

var __vue_render__$7 = function __vue_render__() {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('fieldset', [_vm._ssrNode("<legend>" + _vm._ssrEscape("\n    Item list: " + _vm._s(_vm.vfjsFieldModelKey) + "\n    ") + "<button type=\"button\">add</button></legend> "), _vm._ssrNode("<table>", "</table>", _vm._l(_vm.vfjsFieldModel, function (model, index) {
    return _vm._ssrNode("<tr>", "</tr>", [_vm._ssrNode("<td>", "</td>", [_c('vue-form-json-schema', {
      attrs: {
        "schema": _vm.vfjsFieldSchema.items,
        "ui-schema": _vm.vfjsChildrenUiSchema,
        "model": model,
        "id": _vm.id(index),
        "options": _vm.vfjsOptions
      },
      on: {
        "change": function change(v) {
          return _vm.onChange(index, v);
        }
      }
    })], 1), _vm._ssrNode(" <td><button type=\"button\">remove</button> <button type=\"button\">clone</button></td>")], 2);
  }), 0)], 2);
};

var __vue_staticRenderFns__$7 = [];
/* style */

var __vue_inject_styles__$7 = undefined;
/* scoped */

var __vue_scope_id__$7 = undefined;
/* module identifier */

var __vue_module_identifier__$7 = "data-v-2150b034";
/* functional template */

var __vue_is_functional_template__$7 = false;
/* style inject */

/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$7 = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$7,
  staticRenderFns: __vue_staticRenderFns__$7
}, __vue_inject_styles__$7, __vue_script__$7, __vue_scope_id__$7, __vue_is_functional_template__$7, __vue_module_identifier__$7, false, undefined, undefined, undefined);var script$6 = {
  name: "AvatarCropper",
  props: {
    trigger: {
      type: [String],
      required: true
    },
    uploadHandler: {
      type: Function
    },
    uploadUrl: {
      type: String
    },
    requestMethod: {
      type: String,
      default: "POST"
    },
    uploadHeaders: {
      type: Object
    },
    uploadFormName: {
      type: String,
      default: "file"
    },
    uploadFormData: {
      type: Object,
      default: function _default() {
        return {};
      }
    },
    cropperOptions: {
      type: Object,
      default: function _default() {
        return {
          aspectRatio: 1,
          autoCropArea: 1,
          viewMode: 1,
          movable: false,
          zoomable: false
        };
      }
    },
    outputOptions: {
      type: Object
    },
    outputMime: {
      type: String,
      default: null
    },
    outputQuality: {
      type: Number,
      default: 0.9
    },
    mimes: {
      type: String,
      default: "image/png, image/gif, image/jpeg, image/bmp, image/x-icon"
    },
    labels: {
      type: Object,
      default: function _default() {
        return {
          submit: "Submit",
          cancel: "Cancel"
        };
      }
    },
    withCredentials: {
      type: Boolean,
      default: false
    },
    inline: {
      type: Boolean,
      default: false
    }
  },
  data: function data() {
    return {
      cropper: undefined,
      dataUrl: undefined,
      filename: undefined
    };
  },
  methods: {
    destroy: function destroy() {
      if (this.cropper) {
        this.cropper.destroy();
      }

      this.$refs.input.value = "";
      this.dataUrl = undefined;
    },
    submit: function submit() {
      this.$emit("submit");

      if (this.uploadUrl) {
        this.uploadImage();
      } else if (this.uploadHandler) {
        this.uploadHandler(this.cropper);
      } else {
        this.$emit("error", "No upload handler found.", "user");
      }

      this.destroy();
    },
    cancel: function cancel() {
      this.$emit("cancel");
      this.destroy();
    },
    pickImage: function pickImage(e) {
      this.$refs.input.click();
      e.preventDefault();
      e.stopPropagation();
    },
    createCropper: function createCropper() {
      this.cropper = new Cropper__default['default'](this.$refs.img, this.cropperOptions);
    },
    uploadImage: function uploadImage() {
      var _this = this;

      this.cropper.getCroppedCanvas(this.outputOptions).toBlob(function (blob) {
        var form = new FormData();
        var xhr = new XMLHttpRequest();
        var data = Object.assign({}, _this.uploadFormData);
        xhr.withCredentials = _this.withCredentials;

        for (var key in data) {
          form.append(key, data[key]);
        }

        form.append(_this.uploadFormName, blob, _this.filename);

        _this.$emit("uploading", form, xhr);

        xhr.open(_this.requestMethod, _this.uploadUrl, true);

        for (var header in _this.uploadHeaders) {
          xhr.setRequestHeader(header, _this.uploadHeaders[header]);
        }

        xhr.onreadystatechange = function () {
          if (xhr.readyState === 4) {
            var response = "";

            try {
              response = JSON.parse(xhr.responseText);
            } catch (err) {
              response = xhr.responseText;
            }

            _this.$emit("completed", response, form, xhr);

            if ([200, 201, 204].indexOf(xhr.status) > -1) {
              _this.$emit("uploaded", response, form, xhr);
            } else {
              _this.$emit("error", "Image upload fail.", "upload", xhr);
            }
          }
        };

        xhr.send(form);
      }, this.outputMime, this.outputQuality);
    }
  },
  mounted: function mounted() {
    var _this2 = this;

    // listen for click event on trigger
    var trigger = _typeof(this.trigger) == "object" ? this.trigger : document.querySelector(this.trigger);

    if (!trigger) {
      this.$emit("error", "No avatar make trigger found.", "user");
    } else {
      trigger.addEventListener("click", this.pickImage);
    } // listen for input file changes


    var fileInput = this.$refs.input;
    fileInput.addEventListener("change", function () {
      if (fileInput.files != null && fileInput.files[0] != null) {
        var correctType = _this2.mimes.split(", ").find(function (m) {
          return m === fileInput.files[0].type;
        });

        if (!correctType) {
          _this2.$emit("error", "File type not correct.", "user");

          return;
        }

        var reader = new FileReader();

        reader.onload = function (e) {
          _this2.dataUrl = e.target.result;
        };

        reader.readAsDataURL(fileInput.files[0]);
        _this2.filename = fileInput.files[0].name || "unknown";
        _this2.mimeType = _this2.mimeType || fileInput.files[0].type;

        _this2.$emit("changed", fileInput.files[0], reader);
      }
    });
  }
};function createInjectorSSR(context) {
    if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
        context = __VUE_SSR_CONTEXT__;
    }
    if (!context)
        return () => { };
    if (!('styles' in context)) {
        context._styles = context._styles || {};
        Object.defineProperty(context, 'styles', {
            enumerable: true,
            get: () => context._renderStyles(context._styles)
        });
        context._renderStyles = context._renderStyles || renderStyles;
    }
    return (id, style) => addStyle(id, style, context);
}
function addStyle(id, css, context) {
    const group = css.media || 'default' ;
    const style = context._styles[group] || (context._styles[group] = { ids: [], css: '' });
    if (!style.ids.includes(id)) {
        style.media = css.media;
        style.ids.push(id);
        let code = css.source;
        style.css += code + '\n';
    }
}
function renderStyles(styles) {
    let css = '';
    for (const key in styles) {
        const style = styles[key];
        css +=
            '<style data-vue-ssr-id="' +
                Array.from(style.ids).join(' ') +
                '"' +
                (style.media ? ' media="' + style.media + '"' : '') +
                '>' +
                style.css +
                '</style>';
    }
    return css;
}/* script */
var __vue_script__$6 = script$6;
/* template */

var __vue_render__$6 = function __vue_render__() {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticClass: "avatar-cropper"
  }, [_vm._ssrNode((_vm.dataUrl ? "<div" + _vm._ssrClass("avatar-cropper-overlay", {
    'avatar-cropper-overlay-inline': _vm.inline
  }) + ">" + (!_vm.inline ? "<div class=\"avatar-cropper-mark\"><a" + _vm._ssrAttr("title", _vm.labels.cancel) + " href=\"javascript:;\" class=\"avatar-cropper-close\">×</a></div>" : "<!---->") + " <div class=\"avatar-cropper-container\"><div class=\"avatar-cropper-image-container\"><img" + _vm._ssrAttr("src", _vm.dataUrl) + " alt></div> <div class=\"avatar-cropper-footer\"><button class=\"avatar-cropper-btn\">\n          Cancel\n        </button> <button class=\"avatar-cropper-btn\">\n          Submit\n        </button></div></div></div>" : "<!---->") + " <input" + _vm._ssrAttr("accept", _vm.mimes) + " type=\"file\" class=\"avatar-cropper-img-input\">")]);
};

var __vue_staticRenderFns__$6 = [];
/* style */

var __vue_inject_styles__$6 = function __vue_inject_styles__(inject) {
  if (!inject) return;
  inject("data-v-100cf688_0", {
    source: ".avatar-cropper .avatar-cropper-overlay{text-align:center;display:flex;align-items:center;justify-content:center;position:fixed;top:0;left:0;right:0;bottom:0;z-index:99999}.avatar-cropper .avatar-cropper-overlay-inline{position:initial}.avatar-cropper .avatar-cropper-img-input{display:none}.avatar-cropper .avatar-cropper-close{float:right;padding:20px;font-size:3rem;color:#fff;font-weight:100;text-shadow:0 1px rgba(40,40,40,.3)}.avatar-cropper .avatar-cropper-mark{position:fixed;top:0;left:0;right:0;bottom:0;background:rgba(0,0,0,.1)}.avatar-cropper .avatar-cropper-container{background:#fff;z-index:999;box-shadow:1px 1px 5px rgba(100,100,100,.14)}.avatar-cropper .avatar-cropper-container .avatar-cropper-image-container{position:relative;max-width:400px;height:300px}.avatar-cropper .avatar-cropper-container img{max-width:100%;height:100%}.avatar-cropper .avatar-cropper-container .avatar-cropper-footer{display:flex;align-items:stretch;align-content:stretch;justify-content:space-between}.avatar-cropper .avatar-cropper-container .avatar-cropper-footer .avatar-cropper-btn{width:50%;padding:15px 0;cursor:pointer;border:none;background:0 0;outline:0}.avatar-cropper .avatar-cropper-container .avatar-cropper-footer .avatar-cropper-btn:hover{background-color:#2aabd2;color:#fff}",
    map: undefined,
    media: undefined
  });
};
/* scoped */


var __vue_scope_id__$6 = undefined;
/* module identifier */

var __vue_module_identifier__$6 = "data-v-100cf688";
/* functional template */

var __vue_is_functional_template__$6 = false;
/* style inject shadow dom */

var __vue_component__$6 = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$6,
  staticRenderFns: __vue_staticRenderFns__$6
}, __vue_inject_styles__$6, __vue_script__$6, __vue_scope_id__$6, __vue_is_functional_template__$6, __vue_module_identifier__$6, false, undefined, createInjectorSSR, undefined);//
var script$5 = {
  mixins: [VueFormJsonSchema.vfjsFieldMixin],
  data: function data() {
    return {
      tmpSelectedPhoto: ""
    };
  },
  components: {
    AvatarCropper: __vue_component__$6
  },
  computed: {
    imageUrl: function imageUrl() {
      var model = this.vfjsFieldModel;

      if (model instanceof Blob) {
        return URL.createObjectURL(model);
      }

      return "";
    }
  },
  methods: {
    onInput: function onInput(value) {
      var val = this.vfjsFieldSchema.type === "boolean" ? value : value;
      this.setModel(val);
    },
    photoCancelHandler: function photoCancelHandler() {
      this.tmpSelectedPhoto = "";
    },
    photoChangedHandler: function photoChangedHandler(fileInput) {
      this.tmpSelectedPhoto = fileInput.name;
    },
    photoUploadHandler: function photoUploadHandler(cropper) {
      var _this = this;

      cropper.getCroppedCanvas({
        width: 512,
        height: 512
      }).toBlob(function (blob) {
        _this.setModel(blob);
      }, "image/jpeg", 0.9);
    }
  }
};/* script */
var __vue_script__$5 = script$5;
/* template */

var __vue_render__$5 = function __vue_render__() {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticClass: "form-group"
  }, [_vm._ssrNode("<div id=\"pick-avatar\" class=\"input-group mb-3\"><input type=\"text\" readonly=\"readonly\"" + _vm._ssrAttr("placeholder", _vm.vfjsFieldSchema.title || _vm.vfjsFieldModelKey) + _vm._ssrAttr("value", _vm.tmpSelectedPhoto) + " class=\"form-control\"> <input type=\"text\" name=\"tmpSelectedPhoto\"" + _vm._ssrAttr("required", _vm.vfjsFieldRequired) + _vm._ssrAttr("value", _vm.tmpSelectedPhoto) + " class=\"custom-control-input\"> <div class=\"input-group-append\"><span id=\"basic-addon2\" class=\"input-group-text\">Browse</span></div></div> " + (_vm.vfjsFieldModel ? "<img width=\"200\"" + _vm._ssrAttr("src", _vm.imageUrl) + " alt=\"Preview\" class=\"rounded img-thumbnail img-fluid mx-auto d-block\">" : "<!---->") + " "), _c('AvatarCropper', {
    attrs: {
      "trigger": "#pick-avatar",
      "upload-handler": _vm.photoUploadHandler
    },
    on: {
      "changed": _vm.photoChangedHandler,
      "cancel": _vm.photoCancelHandler
    }
  })], 2);
};

var __vue_staticRenderFns__$5 = [];
/* style */

var __vue_inject_styles__$5 = undefined;
/* scoped */

var __vue_scope_id__$5 = undefined;
/* module identifier */

var __vue_module_identifier__$5 = "data-v-3714a684";
/* functional template */

var __vue_is_functional_template__$5 = false;
/* style inject */

/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$5 = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$5,
  staticRenderFns: __vue_staticRenderFns__$5
}, __vue_inject_styles__$5, __vue_script__$5, __vue_scope_id__$5, __vue_is_functional_template__$5, __vue_module_identifier__$5, false, undefined, undefined, undefined);/*
 * src/mixins.js
 * Created: Thu May 27 2021 23:28:58 GMT+0530 (India Standard Time)
 * Copyright 2021 Harish Karumuthil<harish2704@gmail.com>
 */

function computedPlaceholder() {
  return "Enter " + this.computedLabel;
}

function computedLabel() {
  return this.vfjsFieldSchema.title || this.vfjsFieldModelKey;
}

function computedHelpId() {
  return this.vfjsFieldId + "-help";
}

function computedErrorClass() {
  return this.vfjsComputedFieldHasErrors ? "invalid" : "valid";
}

function computedErrorMessage() {
  return this.vfjsFieldErrors[0] && this.vfjsFieldErrors[0].message;
}

function onInput($event) {
  var val = this.vfjsFieldSchema.type === "boolean" ? $event.target.checked : $event.target.value;
  this.setModel(val);
}

var onInputThrottled = lodash.throttle(onInput, 500);
var appMixins = {
  computed: {
    computedLabel: computedLabel,
    computedPlaceholder: computedPlaceholder,
    computedHelpId: computedHelpId,
    computedErrorClass: computedErrorClass,
    computedErrorMessage: computedErrorMessage
  },
  methods: {
    onInput: onInput,
    onInputThrottled: onInputThrottled
  }
};//

var schemaTypeInputTypeMap = {
  integer: "number",
  boolean: "checkbox"
};
var schemaFormatInputTypeMap = {
  email: "email"
};
var script$4 = {
  mixins: [VueFormJsonSchema.vfjsFieldMixin, appMixins],
  computed: {
    inputType: function inputType() {
      return this.vfjsFieldUiSchema.type || schemaFormatInputTypeMap[this.vfjsFieldSchema.format] || schemaTypeInputTypeMap[this.vfjsFieldSchema.type] || "text";
    }
  }
};/* script */
var __vue_script__$4 = script$4;
/* template */

var __vue_render__$4 = function __vue_render__() {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticClass: "form-group"
  }, [_vm._ssrNode("<label" + _vm._ssrAttr("for", _vm.vfjsFieldId) + ">" + _vm._ssrEscape(_vm._s(_vm.computedLabel)) + "</label> <input" + _vm._ssrAttr("id", _vm.vfjsFieldId) + _vm._ssrAttr("placeholder", _vm.computedPlaceholder) + _vm._ssrAttr("name", _vm.vfjsFieldModelKey) + _vm._ssrAttr("type", _vm.inputType) + _vm._ssrAttr("required", _vm.vfjsFieldRequired) + _vm._ssrAttr("aria-describedby", _vm.computedHelpId) + _vm._ssrAttr("value", _vm.vfjsFieldModel) + _vm._ssrClass(null, 'form-control is-' + _vm.computedErrorClass) + "> <div" + _vm._ssrClass(null, _vm.computedErrorClass + '-feedback') + _vm._ssrStyle(null, null, {
    display: _vm.vfjsComputedShowFieldErrors ? '' : 'none'
  }) + ">" + _vm._ssrEscape("\n    " + _vm._s(_vm.computedErrorMessage) + "\n  ") + "</div> <small" + _vm._ssrAttr("id", _vm.computedHelpId) + " class=\"form-text text-muted\">" + _vm._ssrEscape("\n    " + _vm._s(_vm.vfjsFieldSchema.description) + "\n  ") + "</small>")]);
};

var __vue_staticRenderFns__$4 = [];
/* style */

var __vue_inject_styles__$4 = undefined;
/* scoped */

var __vue_scope_id__$4 = undefined;
/* module identifier */

var __vue_module_identifier__$4 = "data-v-62095d18";
/* functional template */

var __vue_is_functional_template__$4 = false;
/* style inject */

/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$4 = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$4,
  staticRenderFns: __vue_staticRenderFns__$4
}, __vue_inject_styles__$4, __vue_script__$4, __vue_scope_id__$4, __vue_is_functional_template__$4, __vue_module_identifier__$4, false, undefined, undefined, undefined);//
var script$3 = {
  mixins: [VueFormJsonSchema.vfjsFieldMixin, appMixins],
  computed: {
    options: function options() {
      var options = this.vfjsFieldUiSchema.enum || this.vfjsFieldSchema.enum || [];
      return options;
    }
  }
};/* script */
var __vue_script__$3 = script$3;
/* template */

var __vue_render__$3 = function __vue_render__() {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('fieldset', {
    staticClass: "form-group"
  }, [_vm._ssrNode("<legend class=\"col-form-label\">" + _vm._ssrEscape(_vm._s(_vm.computedLabel)) + "</legend> " + _vm._ssrList(_vm.options, function (opt) {
    return "<div" + _vm._ssrClass(null, 'form-check form-check-inline is-' + _vm.computedErrorClass) + "><input type=\"radio\"" + _vm._ssrAttr("name", _vm.vfjsFieldModelKey) + _vm._ssrAttr("id", _vm.vfjsFieldId + opt.value) + _vm._ssrAttr("required", _vm.vfjsFieldRequired) + _vm._ssrAttr("aria-describedby", _vm.computedHelpId) + _vm._ssrAttr("checked", _vm.vfjsFieldModel == opt.value) + _vm._ssrAttr("value", opt.value) + " class=\"form-check-input\"> <label" + _vm._ssrAttr("for", _vm.vfjsFieldId + opt.value) + " class=\"form-check-label\">" + _vm._ssrEscape("\n      " + _vm._s(opt.text || opt) + "\n    ") + "</label></div>";
  }) + " <div" + _vm._ssrClass(null, _vm.computedErrorClass + '-feedback') + _vm._ssrStyle(null, null, {
    display: _vm.vfjsComputedShowFieldErrors ? '' : 'none'
  }) + ">" + _vm._ssrEscape("\n    " + _vm._s(_vm.computedErrorMessage) + "\n  ") + "</div> <small" + _vm._ssrAttr("id", _vm.computedHelpId) + " class=\"form-text text-muted\">" + _vm._ssrEscape("\n    " + _vm._s(_vm.vfjsFieldSchema.description) + "\n  ") + "</small>")]);
};

var __vue_staticRenderFns__$3 = [];
/* style */

var __vue_inject_styles__$3 = undefined;
/* scoped */

var __vue_scope_id__$3 = undefined;
/* module identifier */

var __vue_module_identifier__$3 = "data-v-a238061a";
/* functional template */

var __vue_is_functional_template__$3 = false;
/* style inject */

/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$3 = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$3,
  staticRenderFns: __vue_staticRenderFns__$3
}, __vue_inject_styles__$3, __vue_script__$3, __vue_scope_id__$3, __vue_is_functional_template__$3, __vue_module_identifier__$3, false, undefined, undefined, undefined);var script$2 = {
  mixins: [VueFormJsonSchema.vfjsFieldMixin, appMixins],
  computed: {
    options: function options() {
      var options = this.vfjsFieldUiSchema.enum || this.vfjsFieldSchema.enum || [];

      if (options[0] !== undefined && _typeof(options[0]) !== 'object') {
        return options.map(function (v) {
          return {
            text: v,
            value: v
          };
        });
      }

      return options;
    }
  }
};/* script */
var __vue_script__$2 = script$2;
/* template */

var __vue_render__$2 = function __vue_render__() {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticClass: "form-group"
  }, [_vm._ssrNode("<label" + _vm._ssrAttr("for", _vm.vfjsFieldId) + ">" + _vm._ssrEscape(_vm._s(_vm.computedLabel)) + "</label> <select" + _vm._ssrAttr("id", _vm.vfjsFieldId) + _vm._ssrAttr("placeholder", _vm.computedPlaceholder) + _vm._ssrAttr("name", _vm.vfjsFieldModelKey) + _vm._ssrAttr("required", _vm.vfjsFieldRequired) + _vm._ssrAttr("aria-describedby", _vm.computedHelpId) + _vm._ssrAttr("value", _vm.vfjsFieldModel) + _vm._ssrClass(null, 'form-control is-' + _vm.computedErrorClass) + "><option" + _vm._ssrAttr("value", undefined) + ">\n      -- Please select --\n    </option> " + _vm._ssrList(_vm.options, function (opt) {
    return "<option" + _vm._ssrAttr("value", opt.value) + ">" + _vm._ssrEscape("\n      " + _vm._s(opt.text) + "\n    ") + "</option>";
  }) + "</select> <div" + _vm._ssrClass(null, _vm.computedErrorClass + '-feedback') + _vm._ssrStyle(null, null, {
    display: _vm.vfjsComputedShowFieldErrors ? '' : 'none'
  }) + ">" + _vm._ssrEscape("\n    " + _vm._s(_vm.computedErrorMessage) + "\n  ") + "</div> <small" + _vm._ssrAttr("id", _vm.computedHelpId) + " class=\"form-text text-muted\">" + _vm._ssrEscape("\n    " + _vm._s(_vm.vfjsFieldSchema.description) + "\n  ") + "</small>")]);
};

var __vue_staticRenderFns__$2 = [];
/* style */

var __vue_inject_styles__$2 = undefined;
/* scoped */

var __vue_scope_id__$2 = undefined;
/* module identifier */

var __vue_module_identifier__$2 = "data-v-4c9fb4bf";
/* functional template */

var __vue_is_functional_template__$2 = false;
/* style inject */

/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$2 = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$2,
  staticRenderFns: __vue_staticRenderFns__$2
}, __vue_inject_styles__$2, __vue_script__$2, __vue_scope_id__$2, __vue_is_functional_template__$2, __vue_module_identifier__$2, false, undefined, undefined, undefined);//
var script$1 = {
  name: "select-component",
  mixins: [VueFormJsonSchema.vfjsFieldMixin, appMixins]
};/* script */
var __vue_script__$1 = script$1;
/* template */

var __vue_render__$1 = function __vue_render__() {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticClass: "form-group"
  }, [_vm._ssrNode("<label" + _vm._ssrAttr("for", _vm.vfjsFieldId) + ">" + _vm._ssrEscape(_vm._s(_vm.computedLabel)) + "</label> <textarea" + _vm._ssrAttr("id", _vm.vfjsFieldId) + _vm._ssrAttr("name", _vm.vfjsFieldModelKey) + _vm._ssrAttr("placeholder", _vm.computedPlaceholder) + _vm._ssrAttr("required", _vm.vfjsFieldRequired) + _vm._ssrAttr("aria-describedby", _vm.computedHelpId) + _vm._ssrAttr("value", _vm.vfjsFieldModel) + _vm._ssrClass(null, 'form-control is-' + _vm.computedErrorClass) + "></textarea> <div" + _vm._ssrClass(null, _vm.computedErrorClass + '-feedback') + _vm._ssrStyle(null, null, {
    display: _vm.vfjsComputedShowFieldErrors ? '' : 'none'
  }) + ">" + _vm._ssrEscape("\n    " + _vm._s(_vm.computedErrorMessage) + "\n  ") + "</div> <small" + _vm._ssrAttr("id", _vm.computedHelpId) + " class=\"form-text text-muted\">" + _vm._ssrEscape("\n    " + _vm._s(_vm.vfjsFieldSchema.description) + "\n  ") + "</small>")]);
};

var __vue_staticRenderFns__$1 = [];
/* style */

var __vue_inject_styles__$1 = undefined;
/* scoped */

var __vue_scope_id__$1 = undefined;
/* module identifier */

var __vue_module_identifier__$1 = "data-v-7b9cf6a8";
/* functional template */

var __vue_is_functional_template__$1 = false;
/* style inject */

/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$1 = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$1,
  staticRenderFns: __vue_staticRenderFns__$1
}, __vue_inject_styles__$1, __vue_script__$1, __vue_scope_id__$1, __vue_is_functional_template__$1, __vue_module_identifier__$1, false, undefined, undefined, undefined);//
Vue__default['default'].component("AppArrayContainer", __vue_component__$7);
Vue__default['default'].component("AppImageSelect", __vue_component__$5);
Vue__default['default'].component("AppInput", __vue_component__$4);
Vue__default['default'].component("AppRadioSelect", __vue_component__$3);
Vue__default['default'].component("AppSelect", __vue_component__$2);
Vue__default['default'].component("AppTextarea", __vue_component__$1);

var formOptions = function formOptions() {
  return {
    showValidationErrors: true,
    castToSchemaType: true,
    validateOnLoad: false,
    ajv: {
      plugins: [addFormats__default['default']],
      options: {
        strict: false,
        strictSchema: false
      }
    }
  };
};

var script = {
  props: {
    options: {
      type: Object,
      default: formOptions
    },
    schema: Object,
    value: Object
  },
  computed: {
    uiSchema: function uiSchema() {
      return schemaUtils.getUiSchema(this.schema);
    },
    jsonSchema: function jsonSchema() {
      return schemaUtils.getJsonSchema(this.schema);
    }
  },
  components: {
    VueFormJsonSchema: VueFormJsonSchema__default['default']
  },
  methods: {
    onChange: function onChange(args) {
      this.$emit("input", args);
    }
  }
};/* script */
var __vue_script__ = script;
/* template */

var __vue_render__ = function __vue_render__() {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', [_c('VueFormJsonSchema', {
    attrs: {
      "options": _vm.options,
      "uiSchema": _vm.uiSchema,
      "schema": _vm.jsonSchema,
      "value": _vm.value
    },
    on: {
      "change": _vm.onChange
    }
  })], 1);
};

var __vue_staticRenderFns__ = [];
/* style */

var __vue_inject_styles__ = undefined;
/* scoped */

var __vue_scope_id__ = undefined;
/* module identifier */

var __vue_module_identifier__ = "data-v-3470da88";
/* functional template */

var __vue_is_functional_template__ = false;
/* style inject */

/* style inject SSR */

/* style inject shadow dom */

var __vue_component__ = /*#__PURE__*/normalizeComponent({
  render: __vue_render__,
  staticRenderFns: __vue_staticRenderFns__
}, __vue_inject_styles__, __vue_script__, __vue_scope_id__, __vue_is_functional_template__, __vue_module_identifier__, false, undefined, undefined, undefined);var components$1=/*#__PURE__*/Object.freeze({__proto__:null,HkForm: __vue_component__});var install = function installHkFormBootstrap(Vue) {
  Object.entries(components$1).forEach(function (_ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        componentName = _ref2[0],
        component = _ref2[1];

    Vue.component(componentName, component);
  });
}; // Create module definition for Vue.use()
var components=/*#__PURE__*/Object.freeze({__proto__:null,'default': install,HkForm: __vue_component__});// only expose one global var, with component exports exposed as properties of
// that global var (eg. plugin.component)

Object.entries(components).forEach(function (_ref) {
  var _ref2 = _slicedToArray(_ref, 2),
      componentName = _ref2[0],
      component = _ref2[1];

  if (componentName !== 'default') {
    install[componentName] = component;
  }
});module.exports=install;